	cpu 286
	org 100h

%define	b	byte
%define	w	word
%define	d	dword

start:
	cli
	call	Disable
	mov	sp,ENDDRIVER+200h
	mov	bx,sp
	shr	bx,4
	inc	bx
	mov	ah,4Ah
	int	21h
	mov	ax,3521h
	int	21h
	mov	[old_int_21], bx
	mov	[old_int_21+2], es
	mov	ax,2521h
	mov	dx,Int21hook
	int	21h			;hook int21 to return after decompression
	push	cs
	pop	es
	mov	bx,params
	mov	dx,ExeName
	mov	ax,4B00h
	int	21h			;launch exe
ReturnHere:
	lds	dx,[cs:old_int_21]
	mov	ax,2521h
	int	21h
	push	cs
	pop	ds
	mov	ax,[cs:seg20]
	add	ax,1a0h-18fah
	mov	[seg02],ax
	add	ax,764h-1a0h
	mov	[seg06],ax
	add	ax,28ACh-764h
	mov	[seg23],ax
	add	ax,60fch-28ach
	mov	[seg31],ax
	add	ax,64c6h-60fch
	mov	[dseg],ax
	cli
	mov	ds,ax
	mov	ss,ax
	mov	sp,0f300h
	call	far [cs:seg02call]	;copy sound.rom
	mov	bp,7d6eh
	push	cs
	call	seg20call			;some setup
	push	ax
	mov	es,[cs:seg06]
	mov	b [es:372h],0cbh	;disable disk drive checking stuff
	xor	bp,bp
	push	cs
	call	seg23call			;load default timbres
	mov	bp,6a1fh
	push	cs
	call	seg20call			;init sound driver
	pop	ax
	push	cs
	pop	ds
	mov	dx,NewInt7F
	mov	ax,257Fh
	int	21h
	call	Enable
	sti
@@infyloop:
	mov	ax,9801h
	int	18h
	jmp	@@infyloop
Disable:
	mov	al,80h
	jmp	HootOut
Enable:
	mov	al,81h
HootOut:
	mov	dx,7E8h
	out	dx,al
	ret
Crash:
	cli
	mov	bx,0DEADh
	mov	cx,bx
	mov	dx,bx
@@loop1:
	jmp	@@loop1
;
Int21hook:
	cmp	ah,30h
	jnz	.old
	pop	ax
	cmp	ax,99FEh
	jnz	Crash			;check if correct version of game file
	pop	w [cs:seg20]
	push	cs
	push	ReturnHere
	iret
.old:
	jmp	far [cs:old_int_21]
;
NewInt7F:
	cli
	cld
	pusha
	push	ds
	push	es
	call	Disable
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	mov	dx,7E0h
	in	al,dx
	test	al,al
	jz	@@play
	cmp	al,2
	jnz	@@exitint
	call	@@stop
@@exitint:
	call	Enable
	pop	es
	pop	ds
	popa
	iret
@@play:
	call	@@stop
	mov	dx,7E2h
	in	ax,dx
	push	ax
	mov	bl,ah
	call	Rewind
	mov	ds,[cs:seg31]
	mov	dx,1E88h
	call	ReadFile
	mov	bp,1Ah
	push	cs
	call	seg23call		;setup default timbres
	pop	ax
	test	al,al
	jz	@@no_extra_timbres
	mov	bl,al
	call	Rewind
	mov	ds,[cs:seg31]
	mov	dx,3B4Ah
	call	ReadFile
	xor	bp,bp
@@upload:
	push	w [cs:seg31]
	mov	ax,bp
	imul	ax,33h
	add	ax,3b4ah
	push	ax
	push	bp
	mov	bp,69EDh
	push	cs
	call	seg20call
	pop	bp
	pop	ax
	pop	ax
	inc	bp
	cmp	bp,6
	jb	@@upload
@@no_extra_timbres:
	mov	bp,0e6h
	push	cs
	call	seg23call		;start playback
	jmp	@@exitint
@@stop:
	mov	bp,69fch	;stop music
	push	cs
	call	seg20call
	ret
Rewind:
	xor	bh,bh
	xor	cx,cx
	xor	dx,dx
	mov	ax,4200h
	int	21h
	jc	Crash
	ret
ReadFile:
	mov	cx,-1
	mov	ah,3Fh
	int	21h
	jc	Crash
	ret
seg20call:
	mov	ds,[cs:dseg]
	push	w [cs:seg20]
	push	bp
	retf
seg23call:
	mov	ds,[cs:dseg]
	push	w [cs:seg23]
	push	bp
	retf

ExeName	db 'DK.EXE',0

	align 2

seg02call	dw 0Ah
seg02	dw 0
seg06	dw 0
seg20	dw 0
seg23	dw 0
seg31	dw 0
dseg		dw 0
params	dw 0,0,0,0,0,0,0
old_int_21 dd 0
	db	13,10,13,10,"The Bard's Tale II PC98 Driver v1.0 by Mok"
ENDDRIVER:

	end
