	cpu 286
	org 100h

%define	b	byte
%define	w	word
%define	d	dword

start:
	cli
	call	Disable
	mov	sp,ENDDRIVER+200h
	mov	bx,sp
	shr	bx,4
	inc	bx
	mov	ah,4Ah
	int	21h
;
	mov	bx,2000h
	mov	ah,48h
	int	21h

	mov	[ExeSeg],ax
	mov	[ExeSeg+2],ax
	mov	[seg1],ax
	add	ax,835h
	mov	[dseg],ax

	mov	dx,ExeName
	mov	bx,ExeSeg
	mov	ax,4B03h
	int	21h			;load exe as an overlay
	jc	Crash

	cli
	mov	ax,[dseg]
	mov	ds,ax
	mov	ss,ax
	mov	sp,8400h
	add	ah,10h
	mov	[7682h],ax	;space for mus file
	inc	ah
	mov	[747ah],ax	;space for params

	mov	bx,10
	dec	ah
	mov	ds,ax
	xor	dx,dx
	mov	cx,-1
	mov	ah,3Fh
	int	21h
	jc	Crash

	mov	ds,[cs:seg1]
	mov	al,0cbh
	mov	[068h],al			;retf as most functions are near
	mov	[0a2h],al
	mov	[176h],al
	mov	[0ec3h],al

	mov	bp,65h
	call	DRIVER			;init driver
	cli
	push	cs
	pop	ds
	mov	ax,2508h
	mov	dx,NewInt8
	int	21h
	mov	dx,2
	in	al,dx
	and	al,-2
	out	dx,al
	mov	al,36h
	out	77h,al
	xor	al,al
	out	70h,al
	out	70h,al
	mov	dx,NewInt7F
	mov	ax,257Fh
	int	21h
	call	Enable
	sti
@@infyloop:
	mov	ax,9801h
	int	18h
	jmp	@@infyloop
Disable:
	mov	al,80h
	jmp	HootOut
Enable:
	mov	al,81h
HootOut:
	mov	dx,7E8h
	out	dx,al
	ret
Crash:
	cli
	mov	bx,0DEADh
	mov	cx,bx
	mov	dx,bx
@@loop1:
	jmp	@@loop1
;
NewInt8:
	cli
	pusha
	cmp	b [cs:playing],0
	jz	@@bye
	push	ds
	push	es
	mov	bp,0ebeh
	call	DRIVER			;already done?
	jnz	@@not_yet
	mov	bp,5e63h
	call	DRIVER			;restart
@@not_yet:
	pop	es
	pop	ds
@@bye:
	mov	al,20h
	out	0,al
	popa
	iret

NewInt7F:
	cli
	cld
	pusha
	push	ds
	push	es
	call	Disable
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	mov	dx,7E0h
	in	al,dx
	test	al,al
	jz	@@play
	cmp	al,2
	jnz	@@exitint
	call	@@stop
@@exitint:
	call	Enable
	pop	es
	pop	ds
	popa
	iret
@@play:
	call	@@stop
	mov	dx,7E2h
	in	ax,dx
	mov	bp,09bh
	call	DRIVER
	mov	b [cs:playing],1
	jmp	@@exitint
@@stop:
	mov	b [playing],0
	sti
	mov	bp,15fh
DRIVER:
	mov	w [cs:seg1call],bp
	mov	ds,[cs:dseg]
	call	far [cs:seg1call]
	ret
ExeName	db '.EXE',0
	align 2
seg1call	dw 0
seg1		dw 0
dseg		dw 0
ExeSeg	dw 0,0,0
playing	db 0
	db	13,10,13,10,"Test Drive PC98 Driver v1.0 by Mok"
ENDDRIVER:

	end
